unit uni_u1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Btn_TestUniPort: TButton;
    Btn_TestGiveIO: TButton;
    procedure Btn_TestUniPortClick(Sender: TObject);
    procedure Btn_TestGiveIOClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

uses uniport,giveIO;

{$R *.DFM}

procedure Sound(Frequenz:integer);
var x:integer;
    dw:word;
begin
dw:=1193180 div Frequenz;
x:=ReadPortB($61);
WritePortB($61,x or 3);           //Speaker einschalten
WritePortB($43,$B6);              //Frequenz setzen
WritePortB($42,lo(dw));
WritePortB($42,hi(dw));
end;

procedure NoSound;
var x:integer;
begin
x:=ReadPortB($61);
WritePortB($61,x and not 3);      //Speaker ausschalten
end;

procedure SoundAsm(Frequenz:integer);
var dw:word;
begin
dw:=1193180 div Frequenz;
asm
  mov       dx,$61
  in        al,dx
  or        al,3
  out       dx,al                 //Speaker einschalten
  mov       al,$b6
  mov       dx,$43
  out       dx,al                 //Frequenz setzen ...
  dec       dx
  mov       ax,dw
  out       dx,al
  mov       al,ah
  out       dx,al
 end;
end;

procedure NoSoundAsm;
begin
 asm
  mov       dx,$61
  in        al,dx
  and       al,not 3
  out       dx,al                 //Speaker ausschalten
  end;
end;

procedure TForm1.Btn_TestUniPortClick(Sender: TObject);
var l:integer;
begin
for l:=20 downto 1 do
  begin
   Sound(200+l*300);
   sleep(30);
  end;
NoSound;
end;

procedure TForm1.Btn_TestGiveIOClick(Sender: TObject);
var l:integer;
begin
for l:=1 to 20 do
  begin
   SoundAsm(200+l*300);
   sleep(30);
  end;
NoSoundAsm;
end;

end.
